
	nolist

;*======================================================*
;*	DSPBench v1.0 - DSP module
;*	d.m.l
;*	(latest update 23/02/96)
;*======================================================*

PBC			=	$FFE0
HCR			=	$FFE8
HSR			=	$FFE9
HTX			=	$FFEB

;-------------------------------------------------------*
;	DSP / Host communication macros			*
;-------------------------------------------------------*

dspread_s		macro
_rd	jclr		#0,x:<<HSR,_rd
	move		x:(r7),n7
	move		n7,a
	jclr		#15,n7,_sk
	add		b,a
_sk:	
	endm

dspread_u		macro	acc
_rd	jclr		#0,x:<<HSR,_rd
	move		x:(r7),n7
	move		n7,acc
	endm

dspread			macro	var
_rd	jclr		#0,x:<<HSR,_rd
	movep		x:<<HTX,var
	endm

dspwrite		macro	var
_wr	jclr		#1,x:<<HSR,_wr
	movep		var,x:<<HTX
	endm

dspwaitread		macro
_rd	jclr		#0,x:<<HSR,_rd
	endm

dspwaitwrite		macro
_wr	jclr		#1,x:<<HSR,_wr
	endm


	org		x:0
x_internal:		dc	$123456,$357246,$98765,$ABDCEF,$192837,$715827

	org		y:0
y_internal:		dc	$123456,$357246,$98765,$ABDCEF,$192837,$715827

	org		x:1000
x_external:		dc	$123456,$357246,$98765,$ABDCEF,$192837,$715827

	org		y:1000
y_external:		dc	$123456,$357246,$98765,$ABDCEF,$192837,$715827

;-------------------------------------------------------*
	org		p:0
;-------------------------------------------------------*
	jmp		start
;-------------------------------------------------------*
	org		p:64
;-------------------------------------------------------*

start:

	dspread		a
	dspwrite	a

	move		#8-1,m0
	move		#8-1,m4

	move		#x_internal,r0
	move		#y_internal,r4
	dspread		a
	jsr		i_timeloop
	dspwrite	a

	move		#x_external,r0
	move		#y_internal,r4
	dspread		a
	jsr		i_timeloop
	dspwrite	a

	move		#x_internal,r4
	move		#y_external,r0
	dspread		a
	jsr		i_timeloop
	dspwrite	a

	move		#x_external,r0
	move		#y_external,r4
	dspread		a
	jsr		i_timeloop
	dspwrite	a



	move		#x_internal,r0
	move		#y_internal,r4
	dspread		a
	jsr		e_timeloop
	dspwrite	a

	move		#x_external,r0
	move		#y_internal,r4
	dspread		a
	jsr		e_timeloop
	dspwrite	a

	move		#x_internal,r4
	move		#y_external,r0
	dspread		a
	jsr		e_timeloop
	dspwrite	a

	move		#x_external,r0
	move		#y_external,r4
	dspread		a
	jsr		e_timeloop
	dspwrite	a
	
	jmp		start

code_end:

	org		p:256

i_timeloop:
	move		#8000,x1
	move		x1,y1
	do		y1,_olp
	do		x1,_ilp
	mac		x0,y0,a		x:(r0)+,x0	y:(r4)+,y0
	mac		x0,y0,a		x:(r0)+,x0	y:(r4)+,y0
	mac		x0,y0,a		x:(r0)+,x0	y:(r4)+,y0
	mac		x0,y0,a		x:(r0)+,x0	y:(r4)+,y0
_ilp:	add		a,b	
_olp:	rts

	org		p:512

e_timeloop:
	move		#8000,x1
	move		x1,y1
	do		y1,_olp
	do		x1,_ilp
	mac		x0,y0,a		x:(r0)+,x0	y:(r4)+,y0
	mac		x0,y0,a		x:(r0)+,x0	y:(r4)+,y0
	mac		x0,y0,a		x:(r0)+,x0	y:(r4)+,y0
	mac		x0,y0,a		x:(r0)+,x0	y:(r4)+,y0
_ilp:	add		a,b
_olp:	rts

